> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/android/changelogs/version-10/v10-3-0.md).

# Version 10.3.0 Changelog (August 2, 2023)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

Version: 10.3.0.82541

Release Date: August 2, 2023

## New features

* Adds the ability to move multiple pages together in the thumbnail viewer

![](https://226546913-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F0QItsdFBmuuL9ezHimHy%2Fuploads%2Fgit-blob-039c999b1f36dc7bf8774c136719706bd1ab2438%2Ff9ab1e49ca45d5ef9f89a76123e2a7a24d68b536-600x1233.gif?alt=media)

## Breaking changes

* [`PdfDocModificationListener`](https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/tools/ToolManager.PdfDocModificationListener.html) now includes \[`onPagesMoved`]\(<https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/tools/ToolManager.PdfDocModificationListener.html#onPagesMoved(java.util.List\\>\<java.lang.Integer>, int, int)) callback

## Behavior changes

* `ToolManager.setRichContentEnabledForFreeText(Boolean)` is now a global setting for the Free Text tool
* `ToolManager.setSnappingEnabledForMeasurementTools(Boolean)` is now a global setting for measurement tools

## Notes

This release of Apryse for Android brings the core PDF functionality inline with version 10.3.0 of the Apryse cross-platform APIs. More information can be found on What's new for cross-platform APIs. Most non-module related changes apply to Android.

## Fixed

* Fix issue where the bookmark list is not updated when a new bookmark is added on tablets
* Fix crash where certain documents with OCG layers would throw an `ArrayIndexOutOfBoundsException`

## APIs

### PDFViewCtrlTools package

#### ItemsTouchHelperAdapter

*new* interface: `ItemsTouchHelperAdapter`

*new* method: `void onItemsAdd(List<Integer>, int)`

*new* method: `void onItemsDrop(List<Integer>, int)`

*new* method: `List<Integer> onItemsRemove(List<Integer>)`

#### SimpleMultiTouchHelperCallback

*new* class: `SimpleMultiTouchHelperCallback`

*new* constructor: `SimpleMultiTouchHelperCallback(ItemSelectionHelper, ItemsTouchHelperAdapter, int, boolean, boolean)`

*new* method: `void clearView(RecyclerView, ViewHolder)`

*new* method: `boolean onMove(RecyclerView, ViewHolder, ViewHolder)`

#### ToolConfig

*new* method: `boolean isRichContentEnabledForFreeText()`

*new* method: `boolean isSnappingEnabledForMeasurementTools()`

*new* method: `void setRichContentEnabledForFreeText(boolean)`

*new* method: `void setSnappingEnabledForMeasurementTools(boolean)`

#### PdfViewCtrlTabBaseFragment

*new* method: `void onPagesMoved(List<Integer>, int, int)`

#### ThumbnailsViewAdapter

*new* method: `void moveDocPages(List<Integer>, int)`

*new* method: `void onItemsAdd(List<Integer>, int)`

*new* method: `void onItemsDrop(List<Integer>, int)`

*new* method: `List<Integer> onItemsRemove(List<Integer>)`

*modified* class: `ThumbnailsViewAdapter`

|       | Declaration                                                                                                                                                                           |
| ----- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| From: | public class ThumbnailsViewAdapter extends SimpleRecyclerViewAdapter\<Integer, PageViewHolder> implements ThumbAsyncListener, ItemTouchHelperAdapter, PasswordDialogFragmentListener  |
| To:   | public class ThumbnailsViewAdapter extends SimpleRecyclerViewAdapter\<Integer, PageViewHolder> implements ThumbAsyncListener, ItemsTouchHelperAdapter, PasswordDialogFragmentListener |

#### EditPagesListener

*new* method: `void onPagesMoved(List<Integer>, int)`

#### ThumbnailsViewFragment

*new* method: `void onPagesMoved(List<Integer>, int)`

#### BookmarksDialogFragment

*new* method: `void reloadUserBookmarks()`

#### ToolManager

*new* method: `void raisePagesMoved(List<Integer>, int, int)`

#### PdfDocModificationListener

*new* method: `void onPagesMoved(List<Integer>, int, int)`

#### UndoRedoManager

*new* static method: `boolean isMovePagesAction(Context, String)`

*new* method: `void onPagesMoved(List<Integer>, int, int)`

#### AnnotUtils

*new* static field: `double sMinBitmapAppearanceDPI`

#### BottomBarComponent

*new* method: `void setAlwaysShowIconHighlightColor(int, boolean, int)`

#### BottomBarView

*new* method: `void setAlwaysShowIconHighlightColor(int, boolean, int)`

#### ActionToolbar

*new* method: `void setAlwaysShowIconHighlightColor(int, boolean, int)`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/android/changelogs/version-10/v10-3-0.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
